## jitterentropy-rngd 1.0.8

=== Makefile ===
# Compile Noise Source as user space application

CC=$(CROSS_COMPILE)gcc
STRIP=$(CROSS_COMPILE)strip
CFLAGS ?=-Wextra -Wall -pedantic -fPIE -pie -fstack-protector-strong -fwrapv --param ssp-buffer-size=4
LDFLAGS ?=-Wl,-z,relro,-z,now

# Change as necessary
DESTDIR :=
INSTALL ?= install
PREFIX := /usr/local

NAME := jitterentropy-rngd
#C_SRCS := $(wildcard *.c)
C_SRCS := jitterentropy-base.c jitterentropy-rngd.c
C_OBJS := ${C_SRCS:.c=.o}
OBJS := $(C_OBJS)

INCLUDE_DIRS :=
LIBRARY_DIRS :=
LIBRARIES := rt

CFLAGS += $(foreach includedir,$(INCLUDE_DIRS),-I$(includedir))
LDFLAGS += $(foreach librarydir,$(LIBRARY_DIRS),-L$(librarydir))
LDFLAGS += $(foreach library,$(LIBRARIES),-l$(library))

.PHONY: all clean distclean

all: $(NAME)

$(NAME): $(OBJS)
#	scan-build --use-analyzer=/usr/bin/clang $(CC) $(OBJS) -o $(NAME) $(LDFLAGS)
	$(CC) $(OBJS) -o $(NAME) $(LDFLAGS)

strip: $(NAME)
	$(STRIP) --strip-unneeded $(NAME)

install: strip
	$(INSTALL) -D -m 0755 -s $(NAME) $(DESTDIR)$(PREFIX)/sbin/$(NAME)
	$(INSTALL) -D -m 0644 $(NAME).1 $(DESTDIR)$(PREFIX)/share/man/man1/$(NAME).1
	gzip -9 $(DESTDIR)$(PREFIX)/share/man/man1/$(NAME).1

clean:
	@- $(RM) $(NAME)
	@- $(RM) $(OBJS)

distclean: clean

=== debian/changelog ===
jitterentropy-rngd (1.0.8-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Don't strip during make install. (Closes: #930203)

  [ Luca Boccassi ]
  * Backport 0002-Makefile-support-cross-compiling.patch to fix
    crosscompiling. (Closes: #930203)
  * Bump Standards-Version to 4.3.0, no changes.
  * Set Rules-Requires-Root: no.

 -- Luca Boccassi <bluca@debian.org>  Sat, 08 Jun 2019 12:02:30 +0100

jitterentropy-rngd (1.0.8-3) unstable; urgency=medium

  * Add jitterentropy-rngd.init sysv script.
  * Override Lintian warning about unusual systemd target.
    The daemon needs to start as early as possible to provide entrophy
    during boot.
  * Install upstream changelog.
  * Bump Standards-Version to 4.2.1.

 -- Luca Boccassi <bluca@debian.org>  Fri, 19 Oct 2018 11:47:22 +0100

jitterentropy-rngd (1.0.8-2) unstable; urgency=medium

  * Set homepage to specific project link. (Closes: #904721)
  * Set architecture to linux-any, as this package is linux specific.
  * Bump Standards-Version to 4.1.5, no changes.

 -- Luca Boccassi <bluca@debian.org>  Fri, 27 Jul 2018 09:40:19 +0100

jitterentropy-rngd (1.0.8-1) unstable; urgency=medium

  * Initial packaging. (Closes: #901812)
  * Backport patch to fix systemd unit name and install it.

 -- Luca Boccassi <bluca@debian.org>  Thu, 21 Jun 2018 17:43:43 +0100

=== debian/control ===
Source: jitterentropy-rngd
Section: utils
Priority: optional
Maintainer: Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper (>= 10),
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: http://www.chronox.de/jent.html
Vcs-Git: https://salsa.debian.org/debian/jitterentropy-rngd.git
Vcs-Browser: https://salsa.debian.org/debian/jitterentropy-rngd

Package: jitterentropy-rngd
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Jitter RNG Daemon
 Using the Jitter RNG core, the rngd provides an entropy source that
 feeds into the Linux /dev/random device if its entropy runs low. It
 updates the /dev/random entropy estimator such that the newly provided
 entropy unblocks /dev/random.
 .
 The seeding of /dev/random also ensures that /dev/urandom benefits from
 entropy. Especially during boot time, when the entropy of Linux is low,
 the Jitter RNGd provides a source of sufficient entropy.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with systemd

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr STRIP=true
	install -D -m 0644 jitterentropy.service \
		debian/jitterentropy-rngd/lib/systemd/system/jitterentropy.service

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/,uversionmangle=s/2014/0.2014/" \
 http://www.chronox.de/jent.html jent/jitterentropy-rngd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## jitterentropy-rngd 1.1.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Compile Noise Source as user space application
 
-CC=$(CROSS_COMPILE)gcc
-STRIP=$(CROSS_COMPILE)strip
+CC ?= $(CROSS_COMPILE)gcc
+STRIP ?= $(CROSS_COMPILE)strip
 CFLAGS ?=-Wextra -Wall -pedantic -fPIE -pie -fstack-protector-strong -fwrapv --param ssp-buffer-size=4
 LDFLAGS ?=-Wl,-z,relro,-z,now
 
@@ -9,6 +9,7 @@
 DESTDIR :=
 INSTALL ?= install
 PREFIX := /usr/local
+UNITDIR ?= $(shell pkg-config --variable=systemdsystemunitdir systemd 2>/dev/null || echo /usr/lib/systemd/system)
 
 NAME := jitterentropy-rngd
 #C_SRCS := $(wildcard *.c)
@@ -36,12 +37,15 @@
 	$(STRIP) --strip-unneeded $(NAME)
 
 install: strip
-	$(INSTALL) -D -m 0755 -s $(NAME) $(DESTDIR)$(PREFIX)/sbin/$(NAME)
+	$(INSTALL) -D -m 0755 $(NAME) $(DESTDIR)$(PREFIX)/sbin/$(NAME)
 	$(INSTALL) -D -m 0644 $(NAME).1 $(DESTDIR)$(PREFIX)/share/man/man1/$(NAME).1
 	gzip -9 $(DESTDIR)$(PREFIX)/share/man/man1/$(NAME).1
+	sed "s|@PATH@|$(PREFIX)/sbin|" jitterentropy.service.in > jitterentropy.service
+	$(INSTALL) -D -m 0644 jitterentropy.service $(DESTDIR)$(UNITDIR)/jitterentropy.service
 
 clean:
 	@- $(RM) $(NAME)
 	@- $(RM) $(OBJS)
+	@- $(RM) jitterentropy.service
 
 distclean: clean

=== debian/changelog ===
jitterentropy-rngd (1.1.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.1.0'
  * Drop patches merged upstream in v1.1.0
  * Bump Standards-Version to 4.4.0, no changes
  * d/rules: systemd unit is installed by the makefile now
  * d/rules: CHANGES was renamed to CHANGES.md
  * Add build-dependency on pkg-config and systemd for systemd.pc
  * Enable all hardening flags, 'bind now' was missing
  * d/watch: switch to https

 -- Luca Boccassi <bluca@debian.org>  Sat, 28 Sep 2019 14:06:14 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Build-Depends: debhelper (>= 10),
-Standards-Version: 4.3.0
+Build-Depends: debhelper (>= 10), pkg-config, systemd,
+Standards-Version: 4.4.0
 Rules-Requires-Root: no
 Homepage: http://www.chronox.de/jent.html
 Vcs-Git: https://salsa.debian.org/debian/jitterentropy-rngd.git

=== debian/rules ===
#!/usr/bin/make -f

# Upstream mandates to build without optimizations. It already uses
# pragma to enforce it with GCC, but it doesn't work with Clang.
export DEB_CFLAGS_MAINT_STRIP=-O2
export DEB_CFLAGS_MAINT_APPEND=-O0

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with systemd

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr STRIP=true

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

## jitterentropy-rngd 1.2.1

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,21 @@
 
 CC ?= $(CROSS_COMPILE)gcc
 STRIP ?= $(CROSS_COMPILE)strip
-CFLAGS ?=-Wextra -Wall -pedantic -fPIE -pie -fstack-protector-strong -fwrapv --param ssp-buffer-size=4
-LDFLAGS ?=-Wl,-z,relro,-z,now
+CFLAGS ?=-Wextra -Wall -pedantic -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -fwrapv --param ssp-buffer-size=4 -fvisibility=hidden -fPIE -Wcast-align -Wmissing-field-initializers -Wshadow -Wswitch-enum -O2
+LDFLAGS ?=-Wl,-z,relro,-z,now -pie
+
+GCCVERSIONFORMAT := $(shell echo `$(CC) -dumpversion | sed 's/\./\n/g' | wc -l`)
+ifeq "$(GCCVERSIONFORMAT)" "3"
+  GCC_GTEQ_490 := $(shell expr `$(CC) -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/'` \>= 40900)
+else
+  GCC_GTEQ_490 := $(shell expr `$(CC) -dumpfullversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/'` \>= 40900)
+endif
+
+ifeq "$(GCC_GTEQ_490)" "1"
+  CFLAGS += -fstack-protector-strong
+else
+  CFLAGS += -fstack-protector-all
+endif
 
 # Change as necessary
 DESTDIR :=
@@ -19,7 +32,7 @@
 
 INCLUDE_DIRS :=
 LIBRARY_DIRS :=
-LIBRARIES := rt
+LIBRARIES := rt pthread
 
 CFLAGS += $(foreach includedir,$(INCLUDE_DIRS),-I$(includedir))
 LDFLAGS += $(foreach librarydir,$(LIBRARY_DIRS),-L$(librarydir))

=== debian/changelog ===
jitterentropy-rngd (1.2.1-2) unstable; urgency=medium

  * Backport patches to fix 100% CPU usage bug when running on kernel
    5.11 or newer. (Closes: #985302)
  * Add d/upstream/metadata file

 -- Luca Boccassi <bluca@debian.org>  Mon, 15 Mar 2021 17:07:43 +0000

jitterentropy-rngd (1.2.1-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.1'

 -- Luca Boccassi <bluca@debian.org>  Fri, 22 Jan 2021 11:43:55 +0000

jitterentropy-rngd (1.2.0-1) unstable; urgency=medium

  * Merge branch 'lintian-fixes' into 'master'
  * Update upstream source from tag 'upstream/1.2.0'
  * Bump Standards-Version to 4.5.1, no changes
  * Switch to debhelper-compat 13
  * Use https in d/copyright
  * Add Pre-Depends: ${misc:Pre-Depends}
  * Override Lintian false positive

 -- Luca Boccassi <bluca@debian.org>  Fri, 04 Dec 2020 19:55:20 +0000

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Section: utils
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Build-Depends: debhelper (>= 10), pkg-config, systemd,
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 13), pkg-config, systemd,
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
-Homepage: http://www.chronox.de/jent.html
+Homepage: https://www.chronox.de/jent.html
 Vcs-Git: https://salsa.debian.org/debian/jitterentropy-rngd.git
 Vcs-Browser: https://salsa.debian.org/debian/jitterentropy-rngd
 
 Package: jitterentropy-rngd
 Architecture: linux-any
+Pre-Depends: ${misc:Pre-Depends},
 Depends: ${shlibs:Depends}, ${misc:Depends},
 Description: Jitter RNG Daemon
  Using the Jitter RNG core, the rngd provides an entropy source that

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr STRIP=true

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

## jitterentropy-rngd 1.2.4

=== debian/changelog ===
jitterentropy-rngd (1.2.4-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.4'
  * Bump Standards-Version to 4.6.0, no changes

 -- Luca Boccassi <bluca@debian.org>  Thu, 02 Sep 2021 11:49:24 +0100

jitterentropy-rngd (1.2.3-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.3'
  * Drop all patches, merged upstream.
  * Build with -O0.

 -- Luca Boccassi <bluca@debian.org>  Sun, 15 Aug 2021 13:22:35 +0100

## jitterentropy-rngd 1.2.5

=== debian/changelog ===
jitterentropy-rngd (1.2.5-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.5'

 -- Luca Boccassi <bluca@debian.org>  Sun, 19 Sep 2021 15:13:31 +0100

## jitterentropy-rngd 1.2.6

=== debian/changelog ===
jitterentropy-rngd (1.2.6-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.6'

 -- Luca Boccassi <bluca@debian.org>  Sat, 30 Oct 2021 21:55:25 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
 Build-Depends: debhelper-compat (= 13), pkg-config, systemd,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://www.chronox.de/jent.html
 Vcs-Git: https://salsa.debian.org/debian/jitterentropy-rngd.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+# Compiler optimizations break the entropy generator, upstream
+# fails the build if they are set.
+export DEB_CFLAGS_MAINT_STRIP = -O2
+export DEB_CFLAGS_MAINT_APPEND = -O0
+export DEB_CXXFLAGS_MAINT_STRIP = -O2
+export DEB_CXXFLAGS_MAINT_APPEND = -O0
 
 %:
 	dh $@

## jitterentropy-rngd 1.2.7

=== debian/changelog ===
jitterentropy-rngd (1.2.7-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.7'
  * Bump d/copyright year range
  * Update lintian-overrides syntax

 -- Luca Boccassi <bluca@debian.org>  Sun, 20 Mar 2022 12:50:06 +0000

## jitterentropy-rngd 1.2.8

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 CC ?= $(CROSS_COMPILE)gcc
 STRIP ?= $(CROSS_COMPILE)strip
-CFLAGS ?=-Wextra -Wall -pedantic -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -fwrapv --param ssp-buffer-size=4 -fvisibility=hidden -fPIE -Wcast-align -Wmissing-field-initializers -Wshadow -Wswitch-enum -O2
+CFLAGS ?=-Wextra -Wall -pedantic -fwrapv --param ssp-buffer-size=4 -fvisibility=hidden -fPIE -Wcast-align -Wmissing-field-initializers -Wshadow -Wswitch-enum -O0
 LDFLAGS ?=-Wl,-z,relro,-z,now -pie
 
 GCCVERSIONFORMAT := $(shell echo `$(CC) -dumpversion | sed 's/\./\n/g' | wc -l`)
@@ -25,12 +25,12 @@
 UNITDIR ?= $(shell pkg-config --variable=systemdsystemunitdir systemd 2>/dev/null || echo /usr/lib/systemd/system)
 
 NAME := jitterentropy-rngd
-#C_SRCS := $(wildcard *.c)
-C_SRCS := jitterentropy-base.c jitterentropy-rngd.c
+C_SRCS := $(sort $(wildcard lib/*.c))
+C_SRCS += jitterentropy-rngd.c
 C_OBJS := ${C_SRCS:.c=.o}
 OBJS := $(C_OBJS)
 
-INCLUDE_DIRS :=
+INCLUDE_DIRS := . lib/
 LIBRARY_DIRS :=
 LIBRARIES := rt pthread
 
@@ -38,13 +38,25 @@
 LDFLAGS += $(foreach librarydir,$(LIBRARY_DIRS),-L$(librarydir))
 LDFLAGS += $(foreach library,$(LIBRARIES),-l$(library))
 
-.PHONY: all clean distclean
+analyze_srcs = $(filter %.c, $(sort $(C_SRCS)))
+analyze_plists = $(analyze_srcs:%.c=%.plist)
+
+.PHONY: all scan clean distclean
 
 all: $(NAME)
 
 $(NAME): $(OBJS)
 #	scan-build --use-analyzer=/usr/bin/clang $(CC) $(OBJS) -o $(NAME) $(LDFLAGS)
 	$(CC) $(OBJS) -o $(NAME) $(LDFLAGS)
+
+$(analyze_plists): %.plist: %.c
+	@echo "  CCSA  " $@
+	clang --analyze $(CFLAGS) $< -o $@
+
+scan: $(analyze_plists)
+
+cppcheck:
+	cppcheck --force -q --enable=performance --enable=warning --enable=portability *.h *.c
 
 strip: $(NAME)
 	$(STRIP) --strip-unneeded $(NAME)
@@ -60,5 +72,6 @@
 	@- $(RM) $(NAME)
 	@- $(RM) $(OBJS)
 	@- $(RM) jitterentropy.service
+	@- $(RM) $(analyze_plists)
 
 distclean: clean

=== debian/changelog ===
jitterentropy-rngd (1.2.8-3) unstable; urgency=medium

  * d/control: bump Standards-Version to 4.7.0, no changes
  * Switch to pkgconf
  * Update d/watch to use Github

 -- Luca Boccassi <bluca@debian.org>  Fri, 24 May 2024 15:09:22 +0100

jitterentropy-rngd (1.2.8-2) unstable; urgency=medium

  * Build-depend on systemd-dev instead of systemd (Closes: #1060525)
  * Bump Standards-Version to 4.6.2, no changes
  * Update Lintian overrides

 -- Luca Boccassi <bluca@debian.org>  Thu, 11 Jan 2024 23:46:42 +0000

jitterentropy-rngd (1.2.8-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/1.2.8'
  * Bump Standards-Version to 4.6.1, no changes
  * Update Lintian override syntax

 -- Luca Boccassi <bluca@debian.org>  Tue, 06 Sep 2022 00:39:25 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Luca Boccassi <bluca@debian.org>
-Build-Depends: debhelper-compat (= 13), pkg-config, systemd,
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), pkgconf, systemd-dev,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.chronox.de/jent.html
 Vcs-Git: https://salsa.debian.org/debian/jitterentropy-rngd.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/([\d\.-]+)\.tar\.gz/jitterentropy-rngd-$1.tar.gz/,dversionmangle=s/\+dfsg// \
https://github.com/smuellerDD/jitterentropy-rngd/tags .*/archive/refs/tags/v([\d\.]+).tar.gz
